CON
  _clkmode = xtal1 + pll16x     
  _xinfreq = 5_000_000

  BUFFER_2K     = $800
  
  CR            = $0D
  LF            = $0A
  NULL          = $00
  
  #0, CLOSED, TCP, UDP, IPRAW, MACRAW, PPPOE

  'W5100 I/O
  SPI_MISO          = 0 ' SPI master in serial out from slave 
  SPI_MOSI          = 1 ' SPI master out serial in to slave
  SPI_CS            = 2 ' SPI chip select (active low)
  SPI_SCK           = 3  ' SPI clock from master to all slaves
  WIZ_INT           = 13
  WIZ_RESET         = 14
  SPI_MODE          = 15

  USER_BUTTON       = 23

    
VAR

DAT
  PinHighHeader        byte  "HTTP/1.1 200 OK", CR, LF, {
}                            "Content-Type: text/html", CR, LF, CR, LF 
  PingHighBody         byte  "Pin HIGH", CR, LF, $0

  PinLowHeader         byte  "HTTP/1.1 200 OK", CR, LF, {
}                            "Content-Type: text/html", CR, LF, CR, LF 
  PinLowBody           byte  "Pin LOW", CR, LF, $0

  
  buff            byte  $0[BUFFER_2K]
  fileErrorHandle long  $0
  approot               byte    "\", 0 

OBJ
  pst           : "Parallax Serial Terminal"
  wiz           : "W5100" 
  sock          : "Socket"
 
PUB Main | bytesToRead

  wiz.HardReset(WIZ_RESET)

  bytesToRead := 0
  pst.Start(115_200)
  pause(500)  
  
  'Set network parameters
  wiz.Start(SPI_CS, SPI_SCK, SPI_MOSI, SPI_MISO)  
  wiz.SetCommonnMode(0)

  { Spinneret network configuration }
  wiz.SetGateway(192, 168, 1, 1)                        'Router Address
  wiz.SetSubnetMask(255, 255, 255, 0)                   'Subnet mask
  wiz.SetIp(192, 168, 1, 110)                           'Spinenret IP
  wiz.SetMac($00, $08, $DC, $16, $F8, $01)              'Spinneret mask - label on the underside of the Spinneret

  'Set user button I/O to an input
  DIRA[USER_BUTTON]~
  
  pst.str(string("Initialize Socket",CR))
  sock.Init(0, TCP, 80)

  pst.str(string("Start Socket server",CR))

  pst.str(string("http://"))
  pst.str(PrintIp(wiz.GetIp))

  
  repeat
  
    sock.Open
    sock.Listen

    'Connection?
    repeat until sock.Connected
    
    'Data in the buffer?
    repeat until NULL < bytesToRead := sock.Available

    'Check for a timeout
    if(bytesToRead < 0)
      sock.Disconnect
      bytesToRead~
      next
  
    'Get the Rx buffer  
    sock.Receive(@buff, bytesToRead)

    {{ Process the Rx data}}
    pst.char(CR)
    pst.str(@buff)

    if INA[USER_BUTTON]
      sock.Send(@PinHighHeader, strsize(@PinHighHeader))
    else
      sock.Send(@PinLowHeader, strsize(@PinLowHeader))   

    sock.Disconnect
    
    bytesToRead~


PUB PrintIp(addr) | i
  repeat i from 0 to 3
    pst.dec(byte[addr][i])
    if(i < 3)
      pst.char($2E)
    else
      pst.char($0D)
  
PRI pause(Duration)  
  waitcnt(((clkfreq / 1_000 * Duration - 3932) #> 381) + cnt)
  return